import { Diff } from '../util';
declare module '../schema' {
    interface TypeDefs<State extends SchemaState> {
        strictObject: {
            [P in Diff<keyof State['strictProperties'], State['optional']>]: State['strictProperties'][P];
        } & {
            [P in State['optional']]?: State['strictProperties'][P];
        };
    }
    interface SchemaState {
        strictProperties: any;
        optional: string;
    }
    interface DefaultSchemaState {
        strictProperties: {};
        optional: never;
    }
    interface Schema<State extends SchemaState = DefaultSchemaState> {
        strictProperties<Properties extends {
            [P: string]: Schema<any>;
        }>(properties: Properties): SchemaMultiUpdate<State, 'strictProperties' | 'type', {
            type: 'strictObject';
            strictProperties: {
                [K in keyof Properties]: Properties[K]['TypeOf'];
            };
        }>;
        optional<Properties extends string>(...properties: Properties[]): SchemaUpdate<State, 'optional', Properties>;
    }
}
export declare const strictProperties: never[];
