import { Schema } from './schema';
import { DefaultSchemaState } from './schema';
export { Schema } from './schema';
export { Validator, ValidationError } from './validator';
export declare type schema<T extends Schema<any>> = T['TypeOf'];
export declare const schema: Schema<DefaultSchemaState>, number: Schema<{
    items: any;
    additionalItems: never;
    properties: any;
    required: never;
    additionalProperties: {
        key: string;
        type: any;
    };
    patternProperties: {
        key: never;
        type: never;
    };
    enum: any;
    anyOf: {};
    oneOf: {};
    allOf: {};
    const: any;
    strictProperties: {};
    optional: never;
} & {
    type: "number";
}>, integer: Schema<{
    items: any;
    additionalItems: never;
    properties: any;
    required: never;
    additionalProperties: {
        key: string;
        type: any;
    };
    patternProperties: {
        key: never;
        type: never;
    };
    enum: any;
    anyOf: {};
    oneOf: {};
    allOf: {};
    const: any;
    strictProperties: {};
    optional: never;
} & {
    type: "integer";
}>, string: Schema<{
    items: any;
    additionalItems: never;
    properties: any;
    required: never;
    additionalProperties: {
        key: string;
        type: any;
    };
    patternProperties: {
        key: never;
        type: never;
    };
    enum: any;
    anyOf: {};
    oneOf: {};
    allOf: {};
    const: any;
    strictProperties: {};
    optional: never;
} & {
    type: "string";
}>, boolean: Schema<{
    items: any;
    additionalItems: never;
    properties: any;
    required: never;
    additionalProperties: {
        key: string;
        type: any;
    };
    patternProperties: {
        key: never;
        type: never;
    };
    enum: any;
    anyOf: {};
    oneOf: {};
    allOf: {};
    const: any;
    strictProperties: {};
    optional: never;
} & {
    type: "boolean";
}>, array: Schema<{
    items: any;
    additionalItems: never;
    properties: any;
    required: never;
    additionalProperties: {
        key: string;
        type: any;
    };
    patternProperties: {
        key: never;
        type: never;
    };
    enum: any;
    anyOf: {};
    oneOf: {};
    allOf: {};
    const: any;
    strictProperties: {};
    optional: never;
} & {
    type: "array";
}> & (<ItemsSchema extends Schema<any>>(items: ItemsSchema | ItemsSchema[]) => Schema<{
    type: "array";
    additionalItems: never;
    properties: any;
    required: never;
    additionalProperties: {
        key: string;
        type: any;
    };
    patternProperties: {
        key: never;
        type: never;
    };
    enum: any;
    anyOf: {};
    oneOf: {};
    allOf: {};
    const: any;
    strictProperties: {};
    optional: never;
} & {
    items: ItemsSchema["TypeOf"];
}>), object: Schema<{
    items: any;
    additionalItems: never;
    properties: any;
    required: never;
    additionalProperties: {
        key: string;
        type: any;
    };
    patternProperties: {
        key: never;
        type: never;
    };
    enum: any;
    anyOf: {};
    oneOf: {};
    allOf: {};
    const: any;
    strictProperties: {};
    optional: never;
} & {
    type: "object";
}> & (<Properties extends {
    [P: string]: Schema<any>;
}>(properties: Properties) => Schema<{
    type: "object";
    items: any;
    additionalItems: never;
    required: never;
    additionalProperties: {
        key: string;
        type: any;
    };
    patternProperties: {
        key: never;
        type: never;
    };
    enum: any;
    anyOf: {};
    oneOf: {};
    allOf: {};
    const: any;
    strictProperties: {};
    optional: never;
} & {
    properties: {
        [K in keyof Properties]: Properties[K]["TypeOf"];
    };
}>);
