export declare type JSONPrimitive = string | number | boolean | null;
export interface JSONArray extends Array<AnyJSON> {
}
export interface JSONObject {
    [key: string]: AnyJSON;
}
export declare type AnyJSON = JSONPrimitive | JSONArray | JSONObject;
export declare function copyJson<T>(json: T): T;
export declare function callableInstance<T extends {
    [P in K]: Function;
}, K extends keyof T>(obj: T, key: K): T & T[K];
export declare type Diff<T extends string, U extends string> = ({
    [P in T]: P;
} & {
    [P in U]: never;
} & {
    [x: string]: never;
})[T];
export declare type Overwrite<T, U> = {
    [P in Diff<keyof T, keyof U>]: T[P];
} & U;
export declare type Omit<T, K extends keyof T> = {
    [P in Diff<keyof T, K>]: T[P];
};
