import Ajv = require('ajv');
import { ErrorObject } from 'ajv';
import { Schema } from './schema';
export interface CustomKeyword extends Ajv.KeywordDefinition {
    name: string;
}
export declare type CustomKeywords = Array<CustomKeyword | CustomKeyword[]>;
export interface ValidatorOptions extends Ajv.Options {
    customKeywords?: CustomKeywords;
}
export declare class ValidationError extends Error {
    errors: ErrorObject[];
    constructor(input: any, schema: Schema<any>, errors: ErrorObject[]);
}
export declare class Validator {
    ajv: Ajv.Ajv;
    constructor(options?: ValidatorOptions);
    /**
     * @deprecated use validate instead
     */
    validateSync<T extends Schema<any>>(schema: T, obj: any): {
        valid: false;
        errors: ErrorObject[];
        result: null;
    } | {
        valid: true;
        errors: null;
        result: T['TypeOf'];
    };
    validate<T extends Schema<any>>(schema: T, obj: any): Promise<T['TypeOf']>;
}
