"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Ajv = require("ajv");
function addCustomKeywords(ajv, customKeywords) {
    customKeywords.forEach(function (kw) {
        if (Array.isArray(kw)) {
            addCustomKeywords(ajv, kw);
        }
        else {
            ajv.addKeyword(kw.name, kw);
        }
    });
}
var ValidationError = /** @class */ (function (_super) {
    __extends(ValidationError, _super);
    function ValidationError(input, schema, errors) {
        var _this = _super.call(this, "\n\ncould not validate object:\n" + JSON.stringify(input, null, 2) + "\n\nagainst schema:\n" + JSON.stringify(schema.toJSON(), null, 2) + "\n\nerrors:\n  * " + errors.map(function (e) { return e.message; }).join('\n  * ')) || this;
        _this.errors = errors;
        return _this;
    }
    return ValidationError;
}(Error));
exports.ValidationError = ValidationError;
// tslint:disable-next-line:max-classes-per-file
var Validator = /** @class */ (function () {
    function Validator(options) {
        if (options === void 0) { options = {}; }
        this.ajv = new Ajv(options);
        if (options.customKeywords) {
            addCustomKeywords(this.ajv, options.customKeywords);
        }
    }
    /**
     * @deprecated use validate instead
     */
    Validator.prototype.validateSync = function (schema, obj) {
        var validate = this.ajv.compile(schema.toJSON());
        var coercedValue = {};
        var isValid = validate(obj, undefined, coercedValue, 'result');
        if (isValid) {
            return { errors: null, result: coercedValue.result !== undefined ? coercedValue.result : obj, valid: true };
        }
        else {
            return { errors: validate.errors, result: null, valid: false };
        }
    };
    Validator.prototype.validate = function (schema, obj) {
        var validate = this.ajv.compile(schema.toJSON());
        var coercedValue = {};
        validate(obj, undefined, coercedValue, 'result');
        if (!validate.errors) {
            return Promise.resolve(coercedValue.result !== undefined ? coercedValue.result : obj);
        }
        else {
            return Promise.reject(new ValidationError(obj, schema, validate.errors));
        }
    };
    return Validator;
}());
exports.Validator = Validator;
